{{- $fullname := (include "rtorrent-flood.fullname" .) -}}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "rtorrent-flood.fullname" . }}
  labels:
    {{- include "rtorrent-flood.labels" . | nindent 4 }}
spec:
  replicas: {{ .Values.replicaCount }}
  selector:
    matchLabels:
      {{- include "rtorrent-flood.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      labels:
        {{- include "rtorrent-flood.selectorLabels" . | nindent 8 }}
    spec:
    {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
    {{- end }}
      serviceAccountName: {{ include "rtorrent-flood.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: {{ .Values.image.repository }}:{{ include "rtorrent-flood.imageTag" . }}
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          ports:
            - name: main
              containerPort: 3000
              protocol: TCP
          livenessProbe:
            httpGet:
              port: main
            initialDelaySeconds: {{ .Values.readinessProbe.initialDelaySeconds }}
            periodSeconds: {{ .Values.readinessProbe.periodSeconds }}
          readinessProbe:
            httpGet:
              port: main
            initialDelaySeconds: {{ .Values.readinessProbe.initialDelaySeconds }}
            periodSeconds: {{ .Values.readinessProbe.periodSeconds }}
          {{- with .Values.storage }}
          volumeMounts:
            - name: {{ .data.name }}
              mountPath: "/data"
          {{- end }}
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      {{- with .Values.storage }}
      volumes:
        - name: {{ .data.name }}
          persistentVolumeClaim:
            claimName: {{ if .data.existingClaim -}}
                         {{- .data.existingClaim -}}
                       {{- else -}}
                         {{- $fullname }}-{{ .data.name -}}
                       {{- end }}
      {{- end }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
    {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
    {{- end }}
    {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
    {{- end }}
